{% extends "layouts/presentations/unit_testing.njk" %}

{% set title = "Programming in C++" %}
{% set subtitle = "Unit Testing" %}

{% set language = "C++" %}
{% set language_ = "cpp" %}


{% block framework %}
  <p class="fragment">At the time of this writing,
    <a href="https://www.boost.org/doc/libs/release/libs/test/">Boost Test</a>
    and
    <a href="https://google.github.io/googletest/">GoogleTest</a>
    stand out in terms of quality and features.
  </p>
{% endblock %}

{% block run_tests_before %}
{% highlight "shell" %}
clang++ before_refactoring.cpp test_sum_to.cpp -lgtest_main -lgtest -o run_tests
./run_tests # does not terminate; interrupt via [Ctrl]+[C]
{% endhighlight %}
<p>What to do now?</p>
<div class="fragment">
{% highlight "shell" %}
./run_tests --help
./run_tests --gtest_list_tests  # list all available tests
./run_tests --gtest_filter=sum_to.fast_test
{% endhighlight %}
</div>
{% endblock %}

{% block run_tests_after %}
{% highlight "shell" %}
clang++ after_refactoring.cpp test_sum_to.cpp -lgtest_main -lgtest -o run_tests
./run_tests
{% endhighlight %}
{% endblock %}

{% block about_framework %}
<section>
  <h2>GoogleTest</h2>

  <section>
  <h3>Installation</h3>
{% highlight "shell" %}
sudo apt install googletest
sudo mkdir /usr/src/googletest/build
sudo chown $USER /usr/src/googletest/build
cd /usr/src/googletest/build
cmake ..
make -j4
sudo make install
sudo ldconfig
{% endhighlight %}

  <p>For other operating systems, follow the instructions in project's
    <a href="https://github.com/google/googletest/blob/main/googletest/README.md">README</a>.
  </p>
  </section>

  <section>
    <h3>Documentation</h3>
  <p>Comprehensive documentation can be found in
    <a href="https://google.github.io/googletest/">GoogleTest User’s Guide</a>.
  </p>
  </section>

{#
TODO: create example for gtest and add link here
    <p class="fragment">A slightly
    <a href="https://github.com/HTL-Bulme/c_free_store/blob/main/int_array_test.c">
      more comprehensive example</a> also demonstrates
      <a href="https://en.wikipedia.org/wiki/Test_fixture">text fixtures</a>.
  </p>
#}
</section>
{% endblock %}
